void DB_OnPluginStart()
{
	if (g_dDatabase != null)
		delete g_dDatabase;
	
	char szError[512];
	g_dDatabase = SQL_Connect(MySQL_DATABASE, true, szError, sizeof(szError));
	if (g_dDatabase == null)
	{
		SetFailState("Cannot connect to datbase error: %s", szError);
	}
	
	char szQuery[512];
	FormatEx(szQuery, sizeof(szQuery), "CREATE TABLE IF NOT EXISTS `%sVIPUsers` (`authId` VARCHAR(32) NOT NULL, `expireStamp` INT NOT NULL, UNIQUE (`authId`));", MySQL_TABLE);
	g_dDatabase.Query(SQL_CheckForErrors, szQuery);
	FormatEx(szQuery, sizeof(szQuery), "CREATE TABLE IF NOT EXISTS `%sSVIPUsers` (`authId` VARCHAR(32) NOT NULL, `expireStamp` INT NOT NULL, UNIQUE (`authId`));", MySQL_TABLE);
	g_dDatabase.Query(SQL_CheckForErrors, szQuery);
	FormatEx(szQuery, sizeof(szQuery), "CREATE TABLE IF NOT EXISTS `%sPerks`(`authId` VARCHAR(32) NOT NULL PRIMARY KEY, `chatTag` VARCHAR(512) NOT NULL DEFAULT '', `clanTag` VARCHAR(512) NOT NULL DEFAULT '', `tagColor` VARCHAR(16) NOT NULL DEFAULT '', `nameColor` VARCHAR(16) NOT NULL DEFAULT '', `chatColor` VARCHAR(16) NOT NULL DEFAULT '', `randColor` INT(10) NOT NULL DEFAULT 0,UNIQUE (`authId`))", MySQL_TABLE);
	g_dDatabase.Query(SQL_CheckForErrors, szQuery);
	FormatEx(szQuery, sizeof(szQuery), "CREATE TABLE IF NOT EXISTS `%sCode`(`VIPKEY` VARCHAR(32) NOT NULL, `DAYS` INT(10) NOT NULL DEFAULT 30)", MySQL_TABLE);
	g_dDatabase.Query(SQL_CheckForErrors, szQuery);
	FormatEx(szQuery, sizeof(szQuery), "CREATE TABLE IF NOT EXISTS `%sSVIPCode`(`VIPKEY` VARCHAR(32) NOT NULL, `DAYS` INT(10) NOT NULL DEFAULT 30)", MySQL_TABLE);
	g_dDatabase.Query(SQL_CheckForErrors, szQuery);	
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
			OnClientPostAdminCheck(i);
	}
}

void SQL_FetchSVIPUser(int client)
{
	char szQuery[512];
	FormatEx(szQuery, sizeof(szQuery), "SELECT `expireStamp` FROM `%sSVIPUsers` WHERE `authId` = '%s'", MySQL_TABLE, PlayerData[client].AuthID);
	g_dDatabase.Query(SQL_FetchSVIPUser_CB, szQuery, client);
}

public void SQL_FetchSVIPUser_CB(Database db, DBResultSet results, const char[] error, int client)
{
	if (results == null)
	{
		if (client == 0)
		{
			LogError("client is not valid. Reason: %s", error);
		}
		else
		{
			LogError("Cant use client data on insert. Reason: %s", error);
		}
		return;
	}
	
	if (results.FetchRow())
	{
		int iStamp = results.FetchInt(0);
		if (iStamp - GetTime() > 0)
		{
			PlayerData[client].IsSVIP = true;
			PlayerData[client].SVIPTimesLeft = iStamp;
		}
		else
		{
			char szQuery[512];
			FormatEx(szQuery, sizeof(szQuery), "DELETE FROM `%sSVIPUsers` WHERE `authId` = '%s'", MySQL_TABLE, PlayerData[client].AuthID);
			g_dDatabase.Query(SQL_CheckForErrors, szQuery, client);
		}
	}
	SQL_FetchVIPUser(client);
}

void SQL_FetchVIPUser(int client)
{
	char szQuery[512];
	FormatEx(szQuery, sizeof(szQuery), "SELECT `expireStamp` FROM `%sVIPUsers` WHERE `authId` = '%s'", MySQL_TABLE, PlayerData[client].AuthID);
	g_dDatabase.Query(SQL_FetchVIPUser_CB, szQuery, client);
}

public void SQL_FetchVIPUser_CB(Database db, DBResultSet results, const char[] error, int client)
{
	if (results == null)
	{
		if (client == 0)
		{
			LogError("client is not valid. Reason: %s", error);
		}
		else
		{
			LogError("Cant use client data on insert. Reason: %s", error);
		}
		return;
	}
	
	if (results.FetchRow())
	{
		int iStamp = results.FetchInt(0);
		
		if (iStamp - GetTime() > 0)
		{
			PlayerData[client].IsVIP = true;
			PlayerData[client].VIPTimesLeft = iStamp;
			
		}
		else
		{
			char szQuery[512];
			FormatEx(szQuery, sizeof(szQuery), "DELETE FROM `%sVIPUsers` WHERE `authId` = '%s'", MySQL_TABLE, PlayerData[client].AuthID);
			g_dDatabase.Query(SQL_CheckForErrors, szQuery, client);
		}
	}
	
	SetHudTextParams(-1.0, 0.1, 7.0, 0, 255, 150, 255, 2, 6.0, 0.1, 0.2);
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i))
		{
			if(PlayerData[client].IsVIP && !PlayerData[client].IsSVIP)
				ShowHudText(i, 0, "VIP玩家 %N 已连接", client);
			if(PlayerData[client].IsSVIP)
				ShowHudText(i, 0, "尊贵的SVIP %N 已进入TTeam", client);
		}
	}
	
	if(PlayerData[client].IsVIP || PlayerData[client].IsSVIP)
	{
		GiveFlag(client,VIPFLAG);
		SQL_FetchPerks(client);
	}
	
	Call_StartForward(g_OnPlayerDataReady);
	Call_PushCell(client);
	Call_Finish();
}

void SQL_FetchPerks(int client)
{
	char szQuery[512];
	FormatEx(szQuery, sizeof(szQuery), "SELECT * FROM `%sPerks` WHERE `authId` = '%s'", MySQL_TABLE, PlayerData[client].AuthID);
	g_dDatabase.Query(SQL_FetchPerks_CB, szQuery, client);
}

public void SQL_FetchPerks_CB(Database db, DBResultSet results, const char[] error,int client)
{
	if (results == null)
	{
		if (client == 0)
		{
			LogError("client is not valid. Reason: %s", error);
		}
		else
		{
			LogError("Cant use client data on insert. Reason: %s", error);
		}
		return;
	}
	if (results.FetchRow())
	{
		results.FetchString(1, PlayerData[client].ChatPrefix, 	128);
		results.FetchString(2, PlayerData[client].ClanTag, 		64);
		results.FetchString(3, PlayerData[client].TagColor, 	32);
		results.FetchString(4, PlayerData[client].NameColor, 	32);
		results.FetchString(5, PlayerData[client].ChatColor, 	32);
		if(PlayerData[client].IsSVIP)
			PlayerData[client].IsRandColor = view_as<bool>(results.FetchInt(6));
	} else {
		SQL_RegisterPerks(client);
	}
}

void SQL_RegisterPerks(int client)
{
	char szQuery[512];
	FormatEx(szQuery, sizeof(szQuery), "INSERT INTO `%sPerks` (`authId`) VALUES ('%s')", MySQL_TABLE, PlayerData[client].AuthID);
	g_dDatabase.Query(SQL_CheckForErrors, szQuery);
}

void SQL_UpdatePerk(int client, char[] perk, char[] value)
{
	char szQuery[512];
	FormatEx(szQuery, sizeof(szQuery), "UPDATE `%sPerks` SET `%s` = '%s' WHERE `authId` = '%s'", MySQL_TABLE, perk, value, PlayerData[client].AuthID);
	g_dDatabase.Query(SQL_CheckForErrors, szQuery);
}

void SQL_GetVIP(int client,char[] szArgs)
{
	char query[512],szQuery[512];
	Format(query, sizeof(query),"SELECT `DAYS` FROM `%sCode` WHERE VIPKEY='%s';",MySQL_TABLE, szArgs);
	g_dDatabase.Query(VIPDaysCallBack,query, client);
		
	FormatEx(szQuery, sizeof(szQuery), "DELETE FROM `%sCode` WHERE `VIPKEY` = '%s'",MySQL_TABLE, szArgs);
	g_dDatabase.Query(SQL_CheckForErrors, szQuery);
	strcopy(PlayerData[client].TokenStore,128,szArgs);
}

public void VIPDaysCallBack(Database db, DBResultSet results, const char[] error,int client)
{
	if (results.FetchRow())
	{
		int iDays = results.FetchInt(0);
		if(iDays > 0)
		{

			char szStamp[512];
			char szNewStamp[512];
			Format(szStamp, sizeof(szStamp), "%i", GetTime() + (iDays * 86400));
			Format(szNewStamp, sizeof(szNewStamp), "%i", PlayerData[client].VIPTimesLeft + (iDays * 86400));
			
			PrintToChat(client, "激活 \x02%N \x01 vip ...", client);
			char szQuery[512];
				
			if (PlayerData[client].VIPTimesLeft)
				FormatEx(szQuery, sizeof(szQuery), "UPDATE `%sVIPUsers` SET `expireStamp`= '%s' WHERE `authId` = '%s'",  MySQL_TABLE, szNewStamp, PlayerData[client].AuthID);
			else
				FormatEx(szQuery, sizeof(szQuery), "INSERT INTO `%sVIPUsers` (`authId`, `expireStamp`) VALUES ('%s', '%s')", MySQL_TABLE, PlayerData[client].AuthID, szStamp);
			InsentRandomToken(iDays, 20);
			g_dDatabase.Query(SQL_CheckForErrors, szQuery);		
			SQL_FetchSVIPUser(client);
			PrintToChat(client, "成功激活 \x02%N \x01a vip ", client);
		}
	}
	else
	{
		char query[512],szQuery[512];
		Format(query, sizeof(query),"SELECT `DAYS` FROM `%sSVIPCode` WHERE VIPKEY='%s';",MySQL_TABLE, PlayerData[client].TokenStore);
		g_dDatabase.Query(SVIPDaysCallBack,query, client);
		
		FormatEx(szQuery, sizeof(szQuery), "DELETE FROM `%sSVIPCode` WHERE `VIPKEY` = '%s'",MySQL_TABLE, PlayerData[client].TokenStore);
		g_dDatabase.Query(SQL_CheckForErrors, szQuery);
	}
}

public void SVIPDaysCallBack(Database db, DBResultSet results, const char[] error,int client)
{
	if (results.FetchRow())
	{
		int iDays = results.FetchInt(0);
		if(iDays > 0)
		{

			char szStamp[512];
			char szNewStamp[512];
			Format(szStamp, sizeof(szStamp), "%i", GetTime() + (iDays * 86400));
			Format(szNewStamp, sizeof(szNewStamp), "%i", PlayerData[client].SVIPTimesLeft + (iDays * 86400));
			
			PrintToChat(client, "激活 \x02%N \x01 svip ...", client);
			char szQuery[512];
			
			if (PlayerData[client].SVIPTimesLeft)
				FormatEx(szQuery, sizeof(szQuery), "UPDATE `%sSVIPUsers` SET `expireStamp`= '%s' WHERE `authId` = '%s'",  MySQL_TABLE, szNewStamp, PlayerData[client].AuthID);
			else
				FormatEx(szQuery, sizeof(szQuery), "INSERT INTO `%sSVIPUsers` (`authId`, `expireStamp`) VALUES ('%s', '%s')", MySQL_TABLE, PlayerData[client].AuthID, szStamp);
					
			g_dDatabase.Query(SQL_CheckForErrors, szQuery);	
			InsentRandomToken(iDays, 20, true);	
			PrintToChat(client, "成功激活 \x02%N \x01 svip ", client);
			SQL_FetchSVIPUser(client);
		}
	}
	else
	{
		PrintToChat(client, "小埋酱:无效的激活码哦");
	}
	PlayerData[client].TokenStore = "\0";
}

void Sql_InSentToken(int days, char[] token,bool IsSVIP)
{
	if(IsSVIP)
	{
		char szQuery[1024];
		FormatEx(szQuery, sizeof(szQuery), "INSERT INTO `%sSVIPCode` (`DAYS`, `VIPKEY`) VALUES ('%i', '%s')",MySQL_TABLE, days, token);
		g_dDatabase.Query(SQL_CheckForErrors, szQuery);
	}
	else
	{
		char szQuery[1024];
		FormatEx(szQuery, sizeof(szQuery), "INSERT INTO `%sCode` (`DAYS`, `VIPKEY`) VALUES ('%i', '%s')",MySQL_TABLE, days, token);
		g_dDatabase.Query(SQL_CheckForErrors, szQuery);		
	}
}

public void SQL_CheckForErrors(Database db, DBResultSet results, const char[] error, any data)
{	
	if (!StrEqual(error, ""))
	{
		LogError("Databse error, %s", error);
		return;
	}
}





